; -----------------------------------------------------------------------------
;        ___    __  
;       / _ \  / /    RetroForth for Native/x86 + DOS
; __  _| (_) |/ /_    http://www.retroforth.tk
; \ \/ /> _ <| '_ \ 
;  >  <| (_) | (_) |  Release 6.20 (Final) for NASM
; /_/\_\\___/ \___/   VGA/VESA Graphics
; -----------------------------------------------------------------------------
; This is primarily a wrapper for the other files. It loads the
; macros, sets up memory + stacks, and initializes the Forth
; system. It includes the following files automatically:
;  * macros
;  * forth.asm + forth-ic.asm + forth.f
;  * drivers.asm + drivers.f
;  * user.asm + user.f
; If you're porting RF, you should only need to edit the startup
; code and drivers. The rest should work "out of the box".
; -----------------------------------------------------------------------------
%include "macros"

%define START   0x110000
        tib     equ 0x100000            ;Input buffer (grows upward);
        rp0     equ tib+400h            ;Return stack (grows down)
        sp0     equ rp0+100h            ;Data stack (grows down)
        d0      equ sp0+10h             ;Dictionary header space
        h0      equ START+50000

BITS 32
ORG START

MAIN:   upsh startup            ;Load startup code (startup.f)
        upsh startup.1 - startup
        call eval
        call user_init
;---------------------------------------------------------------------
%include "../forth-ic.asm"
%include "drivers.asm"
%include "user.asm"
%include "../forth.asm"
;---------------------------------------------------------------------
section .data
startup: incbin "../forth.f"
         incbin "drivers.f"
         incbin "user.f"
         db '" RetroForth 6.20" type cr'
.1
END
